package cn.com.qmth.stmms.biz.user.service;

import java.util.List;
import java.util.Set;

import cn.com.qmth.stmms.biz.user.model.User;
import cn.com.qmth.stmms.biz.user.service.query.UserSearchQuery;
import cn.com.qmth.stmms.common.enums.Role;

public interface UserService {

    User login(String loginName, String password, String ip);

    User findByLoginName(String loginName);

    List<User> findByLoginNameAndPassword(String loginName, String password);

    User findById(Integer id);

    List<User> findBySchoolIdAndRole(int schoolId, Role role);

    List<User> findBySchoolIdAndRoleSet(int schoolId, Set<Role> roleSet);

    UserSearchQuery findByQuery(final UserSearchQuery query);

    User save(User user);

    void deleteById(int id);

    void delete(User user);

    User findSchoolAdmin(int schoolId);

    User findSchoolViewer(Integer schoolId);

    User findByMarkerId(Integer markerId);

    User findByLoginNameAndSchoolId(String loginName, Integer schoolId);

}
